Loading...
Searching...
No Matches
pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar > Class Template Reference
Module registration

FPCSInitialAlignment computes corresponding four point congruent sets as described in: "4-points congruent sets for robust pairwise surface registration", Dror Aiger, Niloy Mitra, Daniel Cohen-Or. More...

`#include <pcl/registration/ia_fpcs.h>`

Inheritance diagram for pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >:

## Public Member Functions

| FPCSInitialAlignment ()
| Constructor.
| ~FPCSInitialAlignment () override=default
| Destructor.
void | setTargetIndices (const IndicesPtr &target_indices)
| Provide a pointer to the vector of target indices.
IndicesPtr | getTargetIndices () const
void | setSourceNormals (const NormalsConstPtr &source_normals)
| Provide a pointer to the normals of the source point cloud.
NormalsConstPtr | getSourceNormals () const
void | setTargetNormals (const NormalsConstPtr &target_normals)
| Provide a pointer to the normals of the target point cloud.
NormalsConstPtr | getTargetNormals () const
void | setNumberOfThreads (int nr_threads)
| Set the number of used threads if OpenMP is activated.
int | getNumberOfThreads () const
void | setDelta (float delta, bool normalize=false)
| Set the constant factor delta which weights the internally calculated parameters.
float | getDelta () const
void | setApproxOverlap (float approx_overlap)
| Set the approximate overlap between source and target.
float | getApproxOverlap () const
void | setScoreThreshold (float score_threshold)
| Set the scoring threshold used for early finishing the method.
float | getScoreThreshold () const
void | setNumberOfSamples (int nr_samples)
| Set the number of source samples to use during alignment.
int | getNumberOfSamples () const
void | setMaxNormalDifference (float max_norm_diff)
| Set the maximum normal difference between valid point correspondences in degree.
float | getMaxNormalDifference () const
void | setMaxComputationTime (int max_runtime)
| Set the maximum computation time in seconds.
int | getMaxComputationTime () const
float | getFitnessScore () const
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
| Registration ()
| Empty constructor.
| ~Registration () override=default
| destructor.
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object.
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object.
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target)
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target.
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to)
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target.
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud.
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud.
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding).
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud.
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method.
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method.
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for.
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user.
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for.
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user.
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop.
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user.
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target.
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target.
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) as set by the user.
void | setTransformationRotationEpsilon (double epsilon)
| Set the transformation rotation epsilon (maximum allowable rotation difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationRotationEpsilon ()
| Get the transformation rotation epsilon (maximum allowable difference between two consecutive transformations) as set by the user (epsilon is the cos(angle) in a axis-angle representation).
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user.
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points.
bool | registerVisualizationCallback (std::function< UpdateVisualizerCallbackSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration.
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target)
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points)
bool | hasConverged () const
| Return the state of convergence after the last align run.
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
const std::string & | getClassName () const
| Abstract class get name method.
bool | initCompute ()
| Internal computation initialization.
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed.
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list.
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors.
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list.
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors.
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointSource & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | computeTransformation (PointCloudSource &output, const Eigen::Matrix4f &guess) override
| Rigid transformation computation method.
virtual bool | initCompute ()
| Internal computation initialization.
int | selectBase (pcl::Indices &base_indices, float(&ratio)[2])
| Select an approximately coplanar set of four points from the source cloud.
int | selectBaseTriangle (pcl::Indices &base_indices)
| Select randomly a triplet of points with large point-to-point distances.
void | setupBase (pcl::Indices &base_indices, float(&ratio)[2])
| Setup the base (four coplanar points) by ordering the points and computing intersection ratios and segment to segment distances of base diagonal.
float | segmentToSegmentDist (const pcl::Indices &base_indices, float(&ratio)[2])
| Calculate intersection ratios and segment to segment distances of base diagonals.
virtual int | bruteForceCorrespondences (int idx1, int idx2, pcl::Correspondences &pairs)
| Search for corresponding point pairs given the distance between two base points.
virtual int | determineBaseMatches (const pcl::Indices &base_indices, std::vector< pcl::Indices > &matches, const pcl::Correspondences &pairs_a, const pcl::Correspondences &pairs_b, const float(&ratio)[2])
| Determine base matches by combining the point pair candidate and search for coinciding intersection points using the diagonal segment ratios of base B.
int | checkBaseMatch (const pcl::Indices &match_indices, const float(&ds)[4])
| Check if outer rectangle distance of matched points fit with the base rectangle.
virtual void | handleMatches (const pcl::Indices &base_indices, std::vector< pcl::Indices > &matches, MatchingCandidates &candidates)
| Method to handle current candidate matches.
virtual void | linkMatchWithBase (const pcl::Indices &base_indices, pcl::Indices &match_indices, pcl::Correspondences &correspondences)
| Sets the correspondences between the base B and the match M by using the distance of each point to the centroid of the rectangle.
virtual int | validateMatch (const pcl::Indices &base_indices, const pcl::Indices &match_indices, const pcl::Correspondences &correspondences, Eigen::Matrix4f &transformation)
| Validate the matching by computing the transformation between the source and target based on the four matched points and by comparing the mean square error (MSE) to a threshold.
virtual int | validateTransformation (Eigen::Matrix4f &transformation, float &fitness_score)
| Validate the transformation by calculating the number of inliers after transforming the source cloud.
virtual void | finalCompute (const std::vector< MatchingCandidates > &candidates)
| Final computation of best match out of vector of best matches.
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, pcl::Indices &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point.
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess.
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

NormalsConstPtr | source_normals_
| Normals of source point cloud.
NormalsConstPtr | target_normals_
| Normals of target point cloud.
int | nr_threads_ {1}
| Number of threads for parallelization (standard = 1).
float | approx_overlap_ {0.5f}
| Estimated overlap between source and target (standard = 0.5).
float | delta_ {1.f}
| Delta value of 4pcs algorithm (standard = 1.0).
float | score_threshold_
| Score threshold to stop calculation with success.
int | nr_samples_ {0}
| The number of points to uniformly sample the source point cloud.
float | max_norm_diff_ {90.f}
| Maximum normal difference of corresponding point pairs in degrees (standard = 90).
int | max_runtime_ {0}
| Maximum allowed computation time in seconds (standard = 0 => ~unlimited).
float | fitness_score_
| Resulting fitness score of the best match.
float | diameter_ {0.0f}
| Estimated diameter of the target point cloud.
float | max_base_diameter_sqr_ {0.0f}
| Estimated squared metric overlap between source and target.
bool | use_normals_ {false}
| Use normals flag.
bool | normalize_delta_ {true}
| Normalize delta flag.
pcl::IndicesPtr | source_indices_
| A pointer to the vector of source point indices to use after sampling.
pcl::IndicesPtr | target_indices_
| A pointer to the vector of target point indices to use after sampling.
float | max_pair_diff_ {0.0f}
| Maximal difference between corresponding point pairs in source and target.
float | max_edge_diff_ {0.0f}
| Maximal difference between the length of the base edges and valid match edges.
float | coincidation_limit_ {0.0f}
| Maximal distance between coinciding intersection points to find valid matches.
float | max_mse_ {0.0f}
| Maximal mean squared errors of a transformation calculated from a candidate match.
float | max_inlier_dist_sqr_ {0.0f}
| Maximal squared point distance between source and target points to count as inlier.
const float | small_error_ {0.00001f}
| Definition of a small error.
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, Scalar >
std::string | reg_name_
| The registration method name.
KdTreePtr | tree_
| A pointer to the spatial search object.
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source.
int | nr_iterations_ {0}
| The number of iterations the internal optimization ran for (used internally).
int | max_iterations_ {10}
| The maximum number of iterations the internal optimization should run for.
int | ransac_iterations_ {0}
| The number of iterations RANSAC should run for.
PointCloudTargetConstPtr | target_
| The input point cloud dataset target.
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations.
Matrix4 | transformation_
| The transformation matrix estimated by the registration method.
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally).
double | transformation_epsilon_ {0.0}
| The maximum difference between two consecutive transformations in order to consider convergence (user defined).
double | transformation_rotation_epsilon_ {0.0}
| The maximum rotation difference between two consecutive transformations in order to consider convergence (user defined).
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target.
double | inlier_threshold_ {0.05}
| The inlier distance threshold for the internal RANSAC outlier rejection loop.
bool | converged_ {false}
| Holds internal convergence state, given user parameters.
unsigned int | min_number_correspondences_ {3}
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation.
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step.
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation.
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud.
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use.
bool | target_cloud_updated_ {true}
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again.
bool | source_cloud_updated_ {true}
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again.
bool | force_no_recompute_ {false}
| A flag which, if set, means the tree operating on the target cloud will never be recomputed.
bool | force_no_recompute_reciprocal_ {false}
| A flag which, if set, means the tree operating on the source cloud will never be recomputed.
std::function< UpdateVisualizerCallbackSignature > | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud.
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Public Types inherited from pcl::Registration< PointSource, PointTarget, Scalar >
using | Matrix4 = Eigen::Matrix< Scalar, 4, 4 >
using | Ptr = shared_ptr< Registration< PointSource, PointTarget, Scalar > >
using | ConstPtr = shared_ptr< const Registration< PointSource, PointTarget, Scalar > >
using | CorrespondenceRejectorPtr = pcl::registration::CorrespondenceRejector::Ptr
using | KdTree = pcl::search::KdTree< PointTarget >
using | KdTreePtr = typename KdTree::Ptr
using | KdTreeReciprocal = pcl::search::KdTree< PointSource >
using | KdTreeReciprocalPtr = typename KdTreeReciprocal::Ptr
using | PointCloudSource = pcl::PointCloud< PointSource >
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget = pcl::PointCloud< PointTarget >
using | PointCloudTargetPtr = typename PointCloudTarget::Ptr
using | PointCloudTargetConstPtr = typename PointCloudTarget::ConstPtr
using | PointRepresentationConstPtr = typename KdTree::PointRepresentationConstPtr
using | TransformationEstimation = typename pcl::registration::TransformationEstimation< PointSource, PointTarget, Scalar >
using | TransformationEstimationPtr = typename TransformationEstimation::Ptr
using | TransformationEstimationConstPtr = typename TransformationEstimation::ConstPtr
using | CorrespondenceEstimation = pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >
using | CorrespondenceEstimationPtr = typename CorrespondenceEstimation::Ptr
using | CorrespondenceEstimationConstPtr = typename CorrespondenceEstimation::ConstPtr
using | UpdateVisualizerCallbackSignature = void(const pcl::PointCloud< PointSource > &, const pcl::Indices &, const pcl::PointCloud< PointTarget > &, const pcl::Indices &)
| The callback signature to the function updating intermediate source point cloud position during it's registration to the target point cloud.
Public Types inherited from pcl::PCLBase< PointSource >
using | PointCloud = pcl::PointCloud< PointSource >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Detailed Description

template<typename PointSource, typename PointTarget, typename NormalT = pcl::Normal, typename Scalar = float>
class pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >

FPCSInitialAlignment computes corresponding four point congruent sets as described in: "4-points congruent sets for robust pairwise surface registration", Dror Aiger, Niloy Mitra, Daniel Cohen-Or.

ACM Transactions on Graphics, vol. 27(3), 2008

Author
  P.W.Theiler

Definition at line 81 of file ia_fpcs.h.

## Constructor & Destructor Documentation

## FPCSInitialAlignment()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::FPCSInitialAlignment | ( |  | ) |

Constructor.

Resets the maximum number of iterations to 0 thus forcing an internal computation if not set by the user. Sets the number of RANSAC iterations to 1000 and the standard transformation estimation to TransformationEstimation3Point.

Definition at line 123 of file ia_fpcs.hpp.

References pcl::Registration< PointSource, PointTarget, Scalar >::max_iterations_, pcl::Registration< PointSource, PointTarget, Scalar >::ransac_iterations_, pcl::Registration< PointSource, PointTarget, Scalar >::reg_name_, and pcl::Registration< PointSource, PointTarget, Scalar >::transformation_estimation_.

## ~FPCSInitialAlignment()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::~FPCSInitialAlignment | ( |  | ) |

override default

Destructor.

## Member Function Documentation

## bruteForceCorrespondences()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::bruteForceCorrespondences | ( | int | idx1,
|  | int | idx2,
|  | pcl::Correspondences & | pairs
| ) |  |

protected virtual

Search for corresponding point pairs given the distance between two base points.

Parameters

  [in] | idx1 | first index of current base segment (in source cloud)
  [in] | idx2 | second index of current base segment (in source cloud)
  [out] | pairs | resulting point pairs with point-to-point distance close to ref_dist

Returns
  - < 0 no corresponding point pair was found
  - = 0 at least one point pair candidate was found

Definition at line 552 of file ia_fpcs.hpp.

References pcl::euclideanDistance(), and M_PI.

## checkBaseMatch()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::checkBaseMatch | ( | const pcl::Indices & | match_indices,
|  | const float(&) | ds[4]
| ) |  |

protected

Check if outer rectangle distance of matched points fit with the base rectangle.

Parameters

  [in] | match_indices | indices of match M
  [in] | ds | edge lengths of base B

Returns
  - < 0 at least one edge of the match M has no corresponding one in the base B
  - = 0 edges of match M fits to the ones of base B

Definition at line 688 of file ia_fpcs.hpp.

References pcl::euclideanDistance().

## computeTransformation()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::computeTransformation | ( | PointCloudSource & | output,
|  | const Eigen::Matrix4f & | guess
| ) |  |

override protected

Rigid transformation computation method.

Parameters

  output | the transformed input point cloud dataset using the rigid transformation found
  guess | The computed transforamtion

Definition at line 140 of file ia_fpcs.hpp.

References pcl::StopWatch::getTimeSeconds(), and pcl::transformPointCloud().

## determineBaseMatches()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::determineBaseMatches | ( | const pcl::Indices & | base_indices,
|  | std::vector< pcl::Indices > & | matches,
|  | const pcl::Correspondences & | pairs_a,
|  | const pcl::Correspondences & | pairs_b,
|  | const float(&) | ratio[2]
| ) |  |

protected virtual

Determine base matches by combining the point pair candidate and search for coinciding intersection points using the diagonal segment ratios of base B.

The coincidation threshold is calculated during initialization (coincidation_limit_).

Parameters

  [in] | base_indices | indices of base B
  [out] | matches | vector of candidate matches w.r.t the base B
  [in] | pairs_a | point pairs corresponding to points of 1st diagonal of base B
  [in] | pairs_b | point pairs corresponding to points of 2nd diagonal of base B
  [in] | ratio | diagonal intersection ratios of base points

Returns
  - < 0 no base match could be found
  - = 0 at least one base match was found

Definition at line 606 of file ia_fpcs.hpp.

References pcl::euclideanDistance().

## finalCompute()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::finalCompute | ( | const std::vector< MatchingCandidates > & | candidates | ) |

protected virtual

Final computation of best match out of vector of best matches.

To avoid cross thread dependencies during parallel running, a best match for each try was calculated.

Note
  For forwards compatibility the candidates are stored in vectors of 'vectors of size 1'.

Parameters

  [in] | candidates | vector of candidate matches

Reimplemented in pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 877 of file ia_fpcs.hpp.

## getApproxOverlap()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getApproxOverlap | ( |  | ) | const

inline

Returns
  the approximated overlap between source and target.

Definition at line 208 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::approx_overlap_.

## getDelta()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getDelta | ( |  | ) | const

inline

Returns
  the constant factor delta which weights the internally calculated parameters.

Definition at line 192 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::delta_.

## getFitnessScore()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getFitnessScore | ( |  | ) | const

inline

Returns
  the fitness score of the best scored four-point match.

Definition at line 280 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::fitness_score_.

## getMaxComputationTime()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getMaxComputationTime | ( |  | ) | const

inline

Returns
  the maximum computation time in seconds.

Definition at line 273 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_runtime_.

## getMaxNormalDifference()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getMaxNormalDifference | ( |  | ) | const

inline

Returns
  the maximum normal difference between valid point correspondences in degree.

Definition at line 257 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_norm_diff_.

## getNumberOfSamples()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getNumberOfSamples | ( |  | ) | const

inline

Returns
  the number of source samples to use during alignment.

Definition at line 240 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::nr_samples_.

## getNumberOfThreads()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getNumberOfThreads | ( |  | ) | const

inline

Returns
  the number of threads used if OpenMP is activated.

Definition at line 173 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::nr_threads_.

## getScoreThreshold()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getScoreThreshold | ( |  | ) | const

inline

Returns
  the scoring threshold used for early finishing the method.

Definition at line 224 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::score_threshold_.

## getSourceNormals()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

NormalsConstPtr pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getSourceNormals | ( |  | ) | const

inline

Returns
  the normals of the source point cloud.

Definition at line 141 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::source_normals_.

## getTargetIndices()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

IndicesPtr pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getTargetIndices | ( |  | ) | const

inline

Returns
  a pointer to the vector of target indices.

Definition at line 125 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::target_indices_.

## getTargetNormals()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

NormalsConstPtr pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getTargetNormals | ( |  | ) | const

inline

Returns
  the normals of the target point cloud.

Definition at line 157 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::target_normals_.

## handleMatches()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::handleMatches | ( | const pcl::Indices & | base_indices,
|  | std::vector< pcl::Indices > & | matches,
|  | MatchingCandidates & | candidates
| ) |  |

protected virtual

Method to handle current candidate matches.

Here we validate and evaluate the matches w.r.t the base and store the best fitting match (together with its score and estimated transformation).

Note
  For forwards compatibility the results are stored in 'vectors of size 1'.

Parameters

  [in] | base_indices | indices of base B
  [in,out] | matches | vector of candidate matches w.r.t the base B. The candidate matches are reordered during this step.
  [out] | candidates | vector which contains the candidates matches M

Reimplemented in pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 712 of file ia_fpcs.hpp.

## initCompute()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

bool pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::initCompute | ( |  | ) |

protected virtual

Internal computation initialization.

Reimplemented in pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 213 of file ia_fpcs.hpp.

References pcl::getMinMax3D().

Referenced by pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::initCompute().

## linkMatchWithBase()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::linkMatchWithBase | ( | const pcl::Indices & | base_indices,
|  | pcl::Indices & | match_indices,
|  | pcl::Correspondences & | correspondences
| ) |  |

protected virtual

Sets the correspondences between the base B and the match M by using the distance of each point to the centroid of the rectangle.

Parameters

  [in] | base_indices | indices of base B
  [in] | match_indices | indices of match M
  [out] | correspondences | resulting correspondences

Definition at line 750 of file ia_fpcs.hpp.

References pcl::compute3DCentroid(), and pcl::squaredEuclideanDistance().

## segmentToSegmentDist()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::segmentToSegmentDist | ( | const pcl::Indices & | base_indices,
|  | float(&) | ratio[2]
| ) |  |

protected

Calculate intersection ratios and segment to segment distances of base diagonals.

Parameters

  [in] | base_indices | indices of base B
  [out] | ratio | diagonal intersection ratios of base points

Returns
  quality value of diagonal intersection

Definition at line 467 of file ia_fpcs.hpp.

## selectBase()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::selectBase | ( | pcl::Indices & | base_indices,
|  | float(&) | ratio[2]
| ) |  |

protected

Select an approximately coplanar set of four points from the source cloud.

Parameters

  [out] | base_indices | selected source cloud indices, further used as base (B)
  [out] | ratio | the two diagonal intersection ratios (r1,r2) of the base points

Returns
  - < 0 no coplanar four point sets with large enough sampling distance was found
  - = 0 a set of four congruent points was selected

Definition at line 320 of file ia_fpcs.hpp.

## selectBaseTriangle()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::selectBaseTriangle | ( | pcl::Indices & | base_indices | ) |

protected

Select randomly a triplet of points with large point-to-point distances.

The minimum point sampling distance is calculated based on the estimated point cloud overlap during initialization.

Parameters

  [out] | base_indices | indices of base B

Returns
  - < 0 no triangle with large enough base lines could be selected
  - = 0 base triangle successfully selected

Definition at line 386 of file ia_fpcs.hpp.

## setApproxOverlap()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setApproxOverlap | ( | float | approx_overlap | ) |

inline

Set the approximate overlap between source and target.

Parameters

  [in] | approx_overlap | the estimated overlap

Definition at line 201 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::approx_overlap_.

## setDelta()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setDelta | ( | float | delta,
|  | bool | normalize = `false`
| ) |  |

inline

Set the constant factor delta which weights the internally calculated parameters.

Parameters

  [in] | delta | the weight factor delta
  [in] | normalize | flag if delta should be normalized according to point cloud density

Definition at line 183 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::delta_, and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::normalize_delta_.

## setMaxComputationTime()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setMaxComputationTime | ( | int | max_runtime | ) |

inline

Set the maximum computation time in seconds.

Parameters

  [in] | max_runtime | the maximum runtime of the method in seconds

Definition at line 266 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_runtime_.

## setMaxNormalDifference()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setMaxNormalDifference | ( | float | max_norm_diff | ) |

inline

Set the maximum normal difference between valid point correspondences in degree.

Parameters

  [in] | max_norm_diff | the maximum difference in degree

Definition at line 249 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_norm_diff_.

## setNumberOfSamples()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setNumberOfSamples | ( | int | nr_samples | ) |

inline

Set the number of source samples to use during alignment.

Parameters

  [in] | nr_samples | the number of source samples

Definition at line 233 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::nr_samples_.

## setNumberOfThreads()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setNumberOfThreads | ( | int | nr_threads | ) |

inline

Set the number of used threads if OpenMP is activated.

Parameters

  [in] | nr_threads | the number of used threads

Definition at line 166 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::nr_threads_.

## setScoreThreshold()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setScoreThreshold | ( | float | score_threshold | ) |

inline

Set the scoring threshold used for early finishing the method.

Parameters

  [in] | score_threshold | early terminating score criteria

Definition at line 217 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::score_threshold_.

## setSourceNormals()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setSourceNormals | ( | const NormalsConstPtr & | source_normals | ) |

inline

Provide a pointer to the normals of the source point cloud.

Parameters

  [in] | source_normals | pointer to the normals of the source pointer cloud.

Definition at line 134 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::source_normals_.

## setTargetIndices()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setTargetIndices | ( | const IndicesPtr & | target_indices | ) |

inline

Provide a pointer to the vector of target indices.

Parameters

  [in] | target_indices | a pointer to the target indices

Definition at line 118 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::target_indices_.

## setTargetNormals()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setTargetNormals | ( | const NormalsConstPtr & | target_normals | ) |

inline

Provide a pointer to the normals of the target point cloud.

Parameters

  [in] | target_normals | point to the normals of the target point cloud.

Definition at line 150 of file ia_fpcs.h.

References pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::target_normals_.

## setupBase()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setupBase | ( | pcl::Indices & | base_indices,
|  | float(&) | ratio[2]
| ) |  |

protected

Setup the base (four coplanar points) by ordering the points and computing intersection ratios and segment to segment distances of base diagonal.

Parameters

  [in,out] | base_indices | indices of base B (will be reordered)
  [out] | ratio | diagonal intersection ratios of base points

Definition at line 424 of file ia_fpcs.hpp.

## validateMatch()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::validateMatch | ( | const pcl::Indices & | base_indices,
|  | const pcl::Indices & | match_indices,
|  | const pcl::Correspondences & | correspondences,
|  | Eigen::Matrix4f & | transformation
| ) |  |

protected virtual

Validate the matching by computing the transformation between the source and target based on the four matched points and by comparing the mean square error (MSE) to a threshold.

The MSE limit was calculated during initialization (max_mse_).

Parameters

  [in] | base_indices | indices of base B
  [in] | match_indices | indices of match M
  [in] | correspondences | corresondences between source and target
  [out] | transformation | resulting transformation matrix

Returns
  - < 0 MSE bigger than max_mse_
  - = 0 MSE smaller than max_mse_

Definition at line 803 of file ia_fpcs.hpp.

References pcl::PointCloud< PointT >::points, pcl::squaredEuclideanDistance(), and pcl::transformPointCloud().

## validateTransformation()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::validateTransformation | ( | Eigen::Matrix4f & | transformation,
|  | float & | fitness_score
| ) |  |

protected virtual

Validate the transformation by calculating the number of inliers after transforming the source cloud.

The resulting fitness score is later used as the decision criteria of the best fitting match.

Parameters

  [out] | transformation | updated orientation matrix using all inliers
  [out] | fitness_score | current best fitness_score

Note
  fitness score is only updated if the score of the current transformation exceeds the input one.

Returns
  - < 0 if previous result is better than the current one (score remains)
  - = 0 current result is better than the previous one (score updated)

Reimplemented in pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 835 of file ia_fpcs.hpp.

References pcl::PointCloud< PointT >::begin(), pcl::PointCloud< PointT >::size(), and pcl::transformPointCloud().

## Member Data Documentation

## approx_overlap_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::approx_overlap_ {0.5f}

protected

Estimated overlap between source and target (standard = 0.5).

Definition at line 476 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getApproxOverlap(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setApproxOverlap().

## coincidation_limit_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::coincidation_limit_ {0.0f}

protected

Maximal distance between coinciding intersection points to find valid matches.

Note
  Internally calculated using an estimation of the point density.

Definition at line 542 of file ia_fpcs.h.

## delta_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::delta_ {1.f}

protected

Delta value of 4pcs algorithm (standard = 1.0).

It can be used as:

- absolute value (normalization = false), value should represent the point accuracy to ensure finding neighbors between source <-> target
- relative value (normalization = true), to adjust the internally calculated point accuracy (= point density)

Definition at line 485 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getDelta(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setDelta().

## diameter_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::diameter_ {0.0f}

protected

Estimated diameter of the target point cloud.

Definition at line 508 of file ia_fpcs.h.

## fitness_score_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::fitness_score_

protected

Resulting fitness score of the best match.

Definition at line 505 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getFitnessScore().

## max_base_diameter_sqr_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_base_diameter_sqr_ {0.0f}

protected

Estimated squared metric overlap between source and target.

Note
  Internally calculated using the estimated overlap and the extent of the source cloud. It is used to derive the minimum sampling distance of the base points as well as to calculated the number of tries to reliably find a correct match.

Definition at line 515 of file ia_fpcs.h.

## max_edge_diff_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_edge_diff_ {0.0f}

protected

Maximal difference between the length of the base edges and valid match edges.

Note
  Internally calculated using an estimation of the point density.

Definition at line 537 of file ia_fpcs.h.

## max_inlier_dist_sqr_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_inlier_dist_sqr_ {0.0f}

protected

Maximal squared point distance between source and target points to count as inlier.

Note
  Internally calculated using an estimation of the point density.

Definition at line 552 of file ia_fpcs.h.

## max_mse_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_mse_ {0.0f}

protected

Maximal mean squared errors of a transformation calculated from a candidate match.

Note
  Internally calculated using an estimation of the point density.

Definition at line 547 of file ia_fpcs.h.

## max_norm_diff_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_norm_diff_ {90.f}

protected

Maximum normal difference of corresponding point pairs in degrees (standard = 90).

Definition at line 498 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getMaxNormalDifference(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setMaxNormalDifference().

## max_pair_diff_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_pair_diff_ {0.0f}

protected

Maximal difference between corresponding point pairs in source and target.

Note
  Internally calculated using an estimation of the point density.

Definition at line 532 of file ia_fpcs.h.

## max_runtime_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::max_runtime_ {0}

protected

Maximum allowed computation time in seconds (standard = 0 => ~unlimited).

Definition at line 502 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getMaxComputationTime(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setMaxComputationTime().

## normalize_delta_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

bool pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::normalize_delta_ {true}

protected

Normalize delta flag.

Definition at line 521 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setDelta().

## nr_samples_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::nr_samples_ {0}

protected

The number of points to uniformly sample the source point cloud.

(standard = 0 => full cloud).

Definition at line 494 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getNumberOfSamples(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setNumberOfSamples().

## nr_threads_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

int pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::nr_threads_ {1}

protected

Number of threads for parallelization (standard = 1).

Note
  Only used if run compiled with OpenMP.

Definition at line 473 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getNumberOfThreads(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setNumberOfThreads().

## score_threshold_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::score_threshold_

protected

Score threshold to stop calculation with success.

If not set by the user it depends on the size of the approximated overlap

Definition at line 490 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getScoreThreshold(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setScoreThreshold().

## small_error_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

const float pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::small_error_ {0.00001f}

protected

Definition of a small error.

Definition at line 555 of file ia_fpcs.h.

## source_indices_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

pcl::IndicesPtr pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::source_indices_

protected

A pointer to the vector of source point indices to use after sampling.

Definition at line 524 of file ia_fpcs.h.

## source_normals_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

NormalsConstPtr pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::source_normals_

protected

Normals of source point cloud.

Definition at line 465 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getSourceNormals(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setSourceNormals().

## target_indices_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

pcl::IndicesPtr pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::target_indices_

protected

A pointer to the vector of target point indices to use after sampling.

Definition at line 527 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getTargetIndices(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setTargetIndices().

## target_normals_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

NormalsConstPtr pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::target_normals_

protected

Normals of target point cloud.

Definition at line 468 of file ia_fpcs.h.

Referenced by pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getTargetNormals(), and pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setTargetNormals().

## use_normals_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

bool pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::use_normals_ {false}

protected

Use normals flag.

Definition at line 518 of file ia_fpcs.h.

The documentation for this class was generated from the following files:

- pcl/registration/ia_fpcs.h
- pcl/registration/impl/ia_fpcs.hpp